//plug-in
var gulp = require('gulp');
var browserSync = require('browser-sync');
var plumber = require('gulp-plumber');
var sass = require('gulp-sass');
var sourcemaps = require('gulp-sourcemaps');
var pleeease = require('gulp-pleeease');
var rename = require("gulp-rename");
var uglify = require("gulp-uglify");

// browserSync
gulp.task('browser-sync', function() {
  browserSync({
    server: {
      baseDir: [dir.src],
      directory: true,
      index: 'index.html'
    }
  });
});

gulp.task('bs-reload', function() {
  browserSync.reload();
});

// Sassのコンパイル
gulp.task('sass', function() {
    gulp.src(dir.sass + '*.scss')
        .pipe(plumber())
        .pipe(sourcemaps.init())
        .pipe(sass({
          outputStyle: 'expanded'
        }))
        .pipe(pleeease({
          sass: false,
          rem: false,
          opacity: false,
          autoprefixer: true,
          minifier: false,
          mqpacker: true
        }))
        .pipe(sourcemaps.write(dir.data + 'maps'))
        .pipe(gulp.dest(dir.src + dir.css));
});

// 圧縮版の作成
gulp.task("minfile", function() {
  gulp.src(dir.src + 'js/flex-pulldown.js')
    .pipe(uglify())
    .pipe(rename({
      extname: '.min.js'
    }))
    .pipe(gulp.dest(dir.src + dir.js));

  gulp.src(dir.src + 'css/flex-pulldown.css')
    .pipe(pleeease({
      sass: false,
      rem: false,
      opacity: false,
      autoprefixer: true,
      minifier: true,
      mqpacker: false
    }))
    .pipe(rename({
      extname: '.min.css'
    }))
    .pipe(gulp.dest(dir.src + dir.css));
});

// デフォルト
gulp.task('default', ['browser-sync'], function() {
  gulp.watch([dir.sass + '**/*.scss'], ['sass'], ['bs-reload']);
  gulp.watch([dir.src + '*.html'], ['bs-reload']);
  gulp.watch([dir.src + dir.css + '*.css'], ['bs-reload']);
  gulp.watch([dir.src + dir.js + '*.js'], ['bs-reload']);
  gulp.watch([dir.src + dir.img + '*.img'], ['bs-reload']);
});
